/**
	$Id$

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.migrate;

import java.io.IOException;
import java.sql.SQLException;


/**
	Interface for quick writing of data from a JDBC result set to a
	writer. Implementations need to know at construction time the
	{@link java.sql.ResultSet} to read from, which column index (or indexes)
	to use and the {@link java.io.Writer} to write to.
	
	@author Nicklas
	@since 3.1
	@base.modified $Date$
	@see ResultWriterFactory
*/
public interface ResultWriter 
{
	/**
		Write the current data.
	*/
	public void write()
		throws SQLException, IOException;

	
}
